﻿using System;
using System.Collections.Generic;
using System.Data;
using AsReaderP252B;


namespace AsReaderP252B_Demo
{
    class Device
    {
        private static AsReader asreader = AsReader.SharedAsReader();
        private static AsReaderDelegate asReaderDelegate = new AsReaderP252B.AsReaderDelegate();
        public delegate void WhenReceivedFirmwareVersion(string firmwareVersion);
        public static WhenReceivedFirmwareVersion whenReceivedFirmwareVersion = null;
        public delegate void WhenReceivedHardVersion(string hardVersion);
        public static WhenReceivedHardVersion whenReceivedHardVersion = null;
        public delegate void WhenReceivedRegionCountry(string regionCountry);
        public static WhenReceivedRegionCountry whenReceivedRegionCountry = null;
        public delegate void WhenReceivedSerialNumber(string serialNumber);
        public static WhenReceivedSerialNumber whenReceivedSerialNumber = null;
        public delegate void WhenReceivedRFIDModuleVersion(string rfidModuleVersion);
        public static WhenReceivedRFIDModuleVersion whenReceivedRFIDModuleVersion = null;
        public delegate void WhenReceivedBuzzer(Types.BuzzerStatus buzzerStatus);
        public static WhenReceivedBuzzer whenReceivedBuzzer = null;
        public delegate void WhenReceivedAutoOffSleep(int autoOffSleep);
        public static WhenReceivedAutoOffSleep whenReceivedAutoOffSleep = null;
        public delegate void WhenReceivedQValue(int QValue);
        public static WhenReceivedQValue whenReceivedQValue = null;
        public delegate void WhenReceivedSetQValueResult();
        public static WhenReceivedSetQValueResult whenReceivedSetQValueResult = null;
        public delegate void WhenReceivedQMaxValue(int QMaxValue);
        public static WhenReceivedQMaxValue whenReceivedQMaxValue = null;
        public delegate void WhenReceivedQMinValue(int QMinValue);
        public static WhenReceivedQMinValue whenReceivedQMinValue = null;
        public delegate void WhenReceivedIdleTime(int idleTime);
        public static WhenReceivedIdleTime whenReceivedIdleTime = null;
        public delegate void WhenReceivedAutoOffTime(int autoOffTime);
        public static WhenReceivedAutoOffTime whenReceivedAutoOffTime = null;
        public delegate void WhenReceivedBattery(int battery);
        public static WhenReceivedBattery whenReceivedBattery = null;
        public delegate void WhenReceivedLinkProfile(int linkProfile);
        public static WhenReceivedLinkProfile whenReceivedLinkProfile = null;
        public delegate void WhenReceivedBaudRate(int baudRate);
        public static WhenReceivedBaudRate whenReceivedBaudRate = null;
        public delegate void WhenReceivedBaudRateList(string[] baudRateList);
        public static WhenReceivedBaudRateList whenReceivedBaudRateList = null;
        public delegate void WhenReceivedBarcodeTimeout(int barcodeTimeout);
        public static WhenReceivedBarcodeTimeout whenReceivedBarcodeTimeout = null;
        public delegate void WhenReceivedFrequencyList(string[] frequencyList);
        public static WhenReceivedFrequencyList whenReceivedFrequencyList = null;
        public delegate void WhenReceivedFrequency(int[] frequencyArr);
        public static WhenReceivedFrequency whenReceivedFrequency = null;
        public delegate void WhenReceivedRestoreFactorySettings();
        public static WhenReceivedRestoreFactorySettings whenReceivedRestoreFactorySettings = null;
        public delegate void WhenReceivedSetFrequencyResult();
        public static WhenReceivedSetFrequencyResult whenReceivedSetFrequencyResult = null;
        public delegate void WhenReceivedSetBuzzerResult();
        public static WhenReceivedSetBuzzerResult whenReceivedSetBuzzerResult = null;
        public delegate void WhenReceivedSetIdleTimeResult();
        public static WhenReceivedSetIdleTimeResult whenReceivedSetIdleTimeResult = null;
        public delegate void WhenReceivedSetAutoOffSleepResult();
        public static WhenReceivedSetAutoOffSleepResult whenReceivedSetAutoOffSleepResult = null;
        public delegate void WhenReceivedSetAutoOffTimeResult();
        public static WhenReceivedSetAutoOffTimeResult whenReceivedSetAutoOffTimeResult = null;
        public delegate void WhenReceivedSetBarcodeTimeoutResult();
        public static WhenReceivedSetBarcodeTimeoutResult whenReceivedSetBarcodeTimeoutResult = null;
        public delegate void WhenReceivedStartBarcodeScanResult();
        public static WhenReceivedStartBarcodeScanResult whenReceivedStartBarcodeScanResult = null;
        public delegate void WhenReceivedStopBarcodeScanResult();
        public static WhenReceivedStopBarcodeScanResult whenReceivedStopResult = null;
        public delegate void WhenReceivedBarcodeData(byte[] barcodeData, string typeName);
        public static WhenReceivedBarcodeData whenReceivedBarcodeData = null;
        public delegate void WhenReceivedEPCMaskData(int maskOffset, string maskData, int maskLength);
        public static WhenReceivedEPCMaskData whenReceivedEPCMaskData = null;
        public delegate void WhenReceivedEPCMaskCount(int count);
        public static WhenReceivedEPCMaskCount whenReceivedEPCMaskCount = null;
        public delegate void WhenReceivedClearEPCMaskResult();
        public static WhenReceivedClearEPCMaskResult whenReceivedClearEPCMaskResult = null;
        public delegate void WhenReceivedSetEPCMaskResult();
        public static WhenReceivedSetEPCMaskResult whenReceivedSetEPCMaskResult = null;
        public delegate void WhenReceivedSetPasswordResult();
        public static WhenReceivedSetPasswordResult whenReceivedSetPasswordResult = null;
        public delegate void WhenReceivedReadResult();
        public static WhenReceivedReadResult whenReceivedReadResult = null;
        public delegate void WhenReceivedWriteResult();
        public static WhenReceivedWriteResult whenReceivedWriteResult = null;
        public delegate void WhenReceivedLockResult();
        public static WhenReceivedLockResult whenReceivedLockResult = null;
        public delegate void WhenReceivedKillResult();
        public static WhenReceivedKillResult whenReceivedKillResult = null;

        public delegate void WhenReceivedOperationTime(int operationTime);
        public static WhenReceivedOperationTime whenReceivedOperationTime = null;
        public delegate void WhenReceivedInventoryMode(Types.InventoryMode mode);
        public static WhenReceivedInventoryMode whenReceivedInventoryMode = null;
        public delegate void WhenReceivedRssiOnOff(Types.RssiOnOff OnOff);
        public static WhenReceivedRssiOnOff whenReceivedRssiOnOff = null;
        public delegate void WhenReceivedSessionFlag(int sessionFlag);
        public static WhenReceivedSessionFlag whenReceivedSessionFlag = null;
        public delegate void WhenReceivedSetSessionResult();
        public static WhenReceivedSetSessionResult whenReceivedSetSessionResult = null;
        public delegate void WhenReceivedSetRssiOnOffResult();
        public static WhenReceivedSetRssiOnOffResult whenReceivedSetRssiOnOffResult = null;
        public delegate void WhenReceivedSetSessionFlagResult();
        public static WhenReceivedSetSessionFlagResult whenReceivedSetSessionFlagResult = null;
        public delegate void WhenReceivedSetInventoryModeResult();
        public static WhenReceivedSetInventoryModeResult whenReceivedSetInventoryModeResult = null;
        public delegate void WhenReceivedSetPowerGainResult();
        public static WhenReceivedSetPowerGainResult whenReceivedSetPowerGainResult = null;
        public delegate void WhenReceivedSetOperationTimeResult();
        public static WhenReceivedSetOperationTimeResult whenReceivedSetOperationTimeResult = null;
        public delegate void WhenReceivedPowerGain(int power);
        public static WhenReceivedPowerGain whenReceivedPowerGain = null;
        public delegate void WhenReceivedSession(int session);
        public static WhenReceivedSession whenReceivedSession = null;
        public delegate void WhenReceivedStartInventoryResult();
        public static WhenReceivedStartInventoryResult whenReceivedStartInventoryResult = null;
        public delegate void WhenReceivedTagData(TagData tag);
        public static WhenReceivedTagData whenReceivedTagData = null;
        public delegate void WhenReceivedPowerRange(int min, int max);
        public static WhenReceivedPowerRange whenReceivedPowerRange = null;
        public delegate void WhenReceivedReadTagData(Types.CommandType commandType, Types.ResultCode resultCode, TagData tagData, string[] readMemory);
        public static WhenReceivedReadTagData whenReceivedReadTagData = null;
        public delegate void WhenReceivedTriggerStatus(Types.ButtonActionStatus buttonActionStatus);
        public static WhenReceivedTriggerStatus whenReceivedTriggerStatus = null;
        public delegate void WhenReceivedModeStatus(Types.ButtonActionStatus buttonActionStatus);
        public static WhenReceivedModeStatus whenReceivedModeStatus = null;
        public delegate void WhenReceivedSetLinkProfileResult();
        public static WhenReceivedSetLinkProfileResult whenReceivedSetLinkProfileResult = null;
        public delegate void WhenReceivedSetBaudRateResult();
        public static WhenReceivedSetBaudRateResult whenReceivedSetBaudRateResult = null;
        public delegate void WhenReceivedData(byte[] data);
        public static WhenReceivedData whenReceivedData = null;
        public delegate void WhenReceivedPermaLockResult();
        public static WhenReceivedPermaLockResult whenReceivedPermaLockResult = null;
        public delegate void WhenDeviceIsConnected(bool isConnected);
        public static WhenDeviceIsConnected whenDeviceIsConnected;
        public delegate void WhenReceivedTemperature(string currentTemp);
        public static WhenReceivedTemperature whenReceivedTemperature = null;
        public delegate void WhenReceivedSetTemperatureResult();
        public static WhenReceivedSetTemperatureResult whenReceivedSetTemperatureResult = null;
        public delegate void WhenReceivedWorkTemperature(string workTemp, string threshold);
        public static WhenReceivedWorkTemperature whenReceivedWorkTemperature = null;
        public static void SetDelegates()
        {
            asReaderDelegate.whenReceivedWorkTemperature = (result1, result2) =>
            {
                whenReceivedWorkTemperature?.Invoke(result1, result2);
            };
            asReaderDelegate.whenReceivedTemperature = (result1) =>
            {
                whenReceivedTemperature?.Invoke(result1);
            };
            asReaderDelegate.whenReceivedSetTemperatureResult = () =>
            {
                whenReceivedSetTemperatureResult?.Invoke();
            };
            asReaderDelegate.whenDeviceIsConnected = (result) =>
            {
                whenDeviceIsConnected?.Invoke(result);
            };
            asReaderDelegate.whenReceivedPermaLockResult = () =>
            {
                whenReceivedPermaLockResult?.Invoke();
            };
            asReaderDelegate.whenReceivedData = result =>
            {
                whenReceivedData?.Invoke(result);
            };
            asReaderDelegate.whenReceivedSetBaudRateResult = () =>
            {
                whenReceivedSetBaudRateResult?.Invoke();
            };
            asReaderDelegate.whenReceivedSetLinkProfileResult = () =>
            {
                whenReceivedSetLinkProfileResult?.Invoke();
            };
            asReaderDelegate.whenReceivedSetQValueResult = () =>
            {
                whenReceivedSetQValueResult?.Invoke();
            };
            asReaderDelegate.whenReceivedTriggerStatus = result =>
            {
                whenReceivedTriggerStatus?.Invoke(result);
            };
            asReaderDelegate.whenReceivedModeStatus = result =>
            {
                whenReceivedModeStatus?.Invoke(result);
            };
            asReaderDelegate.whenReceivedReadTagData = (result1, result2, result3, result4) =>
            {
                whenReceivedReadTagData?.Invoke(result1, result2, result3, result4);
            };
            asReaderDelegate.whenReceivedPowerRange = (result1, result2) =>
            {
                whenReceivedPowerRange?.Invoke(result1, result2);
            };
            asReaderDelegate.whenReceivedTagData = result =>
            {
                whenReceivedTagData?.Invoke(result);
            };
            asReaderDelegate.whenReceivedStartInventoryResult = () =>
            {
                whenReceivedStartInventoryResult?.Invoke();
            };
            asReaderDelegate.whenReceivedSession = (result) =>
            {
                whenReceivedSession?.Invoke(result);
            };
            asReaderDelegate.whenReceivedPowerGain = (result) =>
            {
                whenReceivedPowerGain?.Invoke(result);
            };
            asReaderDelegate.whenReceivedSetOperationTimeResult = () =>
            {
                whenReceivedSetOperationTimeResult?.Invoke();
            };
            asReaderDelegate.whenReceivedSetPowerGainResult = () =>
            {
                whenReceivedSetPowerGainResult?.Invoke();
            };
            asReaderDelegate.whenReceivedSetInventoryModeResult = () =>
            {
                whenReceivedSetInventoryModeResult?.Invoke();
            };
            asReaderDelegate.whenReceivedSetSessionFlagResult = () =>
            {
                whenReceivedSetSessionFlagResult?.Invoke();
            };
            asReaderDelegate.whenReceivedSetRssiOnOffResult = () =>
            {
                whenReceivedSetRssiOnOffResult?.Invoke();
            };
            asReaderDelegate.whenReceivedSetSessionResult = () =>
            {
                whenReceivedSetSessionResult?.Invoke();
            };
            asReaderDelegate.whenReceivedSessionFlag = result =>
            {
                whenReceivedSessionFlag?.Invoke(result);
            };
            asReaderDelegate.whenReceivedRssiOnOff = result =>
            {
                whenReceivedRssiOnOff?.Invoke(result);
            };
            asReaderDelegate.whenReceivedInventoryMode = result =>
            {
                whenReceivedInventoryMode?.Invoke(result);
            };
            asReaderDelegate.whenReceivedOperationTime = result =>
            {
                whenReceivedOperationTime?.Invoke(result);
            };
            asReaderDelegate.whenReceivedKillResult = () =>
            {
                whenReceivedKillResult?.Invoke();
            };
            asReaderDelegate.whenReceivedLockResult = () =>
            {
                whenReceivedLockResult?.Invoke();
            };
            asReaderDelegate.whenReceivedWriteResult = () =>
            {
                whenReceivedWriteResult?.Invoke();
            };
            asReaderDelegate.whenReceivedReadResult = () =>
            {
                whenReceivedReadResult?.Invoke();
            };
            asReaderDelegate.whenReceivedSetPasswordResult = () =>
            {
                whenReceivedSetPasswordResult?.Invoke();
            };
            asReaderDelegate.whenReceivedSetEPCMaskResult = () =>
            {
                whenReceivedSetEPCMaskResult?.Invoke();
            };
            asReaderDelegate.whenReceivedClearEPCMaskResult = () =>
            {
                whenReceivedClearEPCMaskResult?.Invoke();
            };
            asReaderDelegate.whenReceivedEPCMaskData = (result1, result2, result3) =>
            {
                whenReceivedEPCMaskData?.Invoke(result1, result2, result3);
            };
            asReaderDelegate.whenReceivedBarcodeData = (result1, result2) =>
            {
                whenReceivedBarcodeData?.Invoke(result1, result2);
            };
            asReaderDelegate.whenReceivedStopResult = () =>
            {
                whenReceivedStopResult?.Invoke();
            };
            asReaderDelegate.whenReceivedStartBarcodeScanResult = () =>
            {
                whenReceivedStartBarcodeScanResult?.Invoke();
            };
            asReaderDelegate.whenReceivedSetBarcodeTimeoutResult = () =>
            {
                whenReceivedSetBarcodeTimeoutResult?.Invoke();
            };
            asReaderDelegate.whenReceivedSetAutoOffTimeResult = () =>
            {
                whenReceivedSetAutoOffTimeResult?.Invoke();
            };
            asReaderDelegate.whenReceivedSetAutoOffSleepResult = () =>
            {
                whenReceivedSetAutoOffSleepResult?.Invoke();
            };
            asReaderDelegate.whenReceivedSetIdleTimeResult = () =>
            {
                whenReceivedSetIdleTimeResult?.Invoke();
            };
            asReaderDelegate.whenReceivedSetBuzzerResult = () =>
            {
                whenReceivedSetBuzzerResult?.Invoke();
            };
            asReaderDelegate.whenReceivedSetFrequencyResult = () =>
            {
                whenReceivedSetFrequencyResult?.Invoke();
            };
            asReaderDelegate.whenReceivedRestoreFactorySettings = () =>
            {
                whenReceivedRestoreFactorySettings?.Invoke();
            };
            asReaderDelegate.whenReceivedFrequency = result =>
            {
                whenReceivedFrequency?.Invoke(result);
            };
            asReaderDelegate.whenReceivedFrequencyList = result =>
            {
                whenReceivedFrequencyList?.Invoke(result);
            };
            asReaderDelegate.whenReceivedBarcodeTimeout = result =>
            {
                whenReceivedBarcodeTimeout?.Invoke(result);
            };
            asReaderDelegate.whenReceivedBaudRateList = result =>
            {
                whenReceivedBaudRateList?.Invoke(result);
            };
            asReaderDelegate.whenReceivedBaudRate = result =>
            {
                whenReceivedBaudRate?.Invoke(result);
            };
            asReaderDelegate.whenReceivedFirmwareVersion = result =>
            {
                whenReceivedFirmwareVersion?.Invoke(result);
            };
            asReaderDelegate.whenReceivedHardVersion = result =>
            {
                whenReceivedHardVersion?.Invoke(result);
            };
            asReaderDelegate.whenReceivedRegionCountry = result =>
            {
                whenReceivedRegionCountry?.Invoke(result);
            };
            asReaderDelegate.whenReceivedSerialNumber = result =>
            {
                whenReceivedSerialNumber?.Invoke(result);
            };
            asReaderDelegate.whenReceivedRFIDModuleVersion = result =>
            {
                whenReceivedRFIDModuleVersion?.Invoke(result);
            };
            asReaderDelegate.whenReceivedBuzzer = result =>
            {
                whenReceivedBuzzer?.Invoke(result);
            };
            asReaderDelegate.whenReceivedAutoOffSleep = result =>
            {
                whenReceivedAutoOffSleep?.Invoke(result);
            };
            asReaderDelegate.whenReceivedAutoOffTime = result =>
            {
                whenReceivedAutoOffTime?.Invoke(result);
            };
            asReaderDelegate.whenReceivedQValue = result =>
            {
                whenReceivedQValue?.Invoke(result);
            };
            asReaderDelegate.whenReceivedQMaxValue = result =>
            {
                whenReceivedQMaxValue?.Invoke(result);
            };
            asReaderDelegate.whenReceivedQMinValue = result =>
            {
                whenReceivedQMinValue?.Invoke(result);
            };
            asReaderDelegate.whenReceivedIdleTime = result =>
            {
                whenReceivedIdleTime?.Invoke(result);
            };
            asReaderDelegate.whenReceivedBattery = result =>
            {
                whenReceivedBattery?.Invoke(result);
            };
            asReaderDelegate.whenReceivedLinkProfile = result =>
            {
                whenReceivedLinkProfile?.Invoke(result);
            }; 
            asreader.SetDelegates(asReaderDelegate);
        }
        public static UInt32 Connect(string comPort, int baudrate)
        {
            UInt32 ret = asreader.Connect(comPort, baudrate);
            return ret;
        }
        public static UInt32 Connect(BluetoothDevice bluetoothDevice)
        {
            UInt32 ret = asreader.Connect(bluetoothDevice);
            return ret;
        }
        public static UInt32 Disconnect()
        {
            return asreader.Disconnect();
        }
        public static UInt32 GetFirmwareVersion()
        {
            return asreader.GetFirmwareVersion();
        }
        public static UInt32 GetHardVersion()
        {
            return asreader.GetHardVersion();
        }
        public static UInt32 GetRegionCountry()
        {
            return asreader.GetRegionCountry();
        }
        public static UInt32 GetOperationTime()
        {
            return asreader.GetOperationTime();
        }
        public static UInt32 GetSerialNumber()
        {
            return asreader.GetSerialNumber();
        }
        public static UInt32 GetRFIDModuleVersion()
        {
            return asreader.GetRFIDModuleVersion();
        }
        public static UInt32 GetBuzzer()
        {
            return asreader.GetBuzzer();
        }
        public static UInt32 GetAutoOffSleep()
        {
            return asreader.GetAutoOffSleep();
        }
        public static UInt32 GetAutoOffTime()
        {
            return asreader.GetAutoOffTime();
        }
        public static UInt32 GetQValue()
        {
            return asreader.GetQValue();
        }
        public static UInt32 GetQMaxValue()
        {
            return asreader.GetQMaxValue();
        }
        public static UInt32 GetQMinValue()
        {
            return asreader.GetQMinValue();
        }
        public static UInt32 GetIdleTime()
        {
            return asreader.GetIdleTime();
        }
        public static UInt32 GetBattery()
        {
            return asreader.GetBattery();
        }
        public static UInt32 GetSessionFlag()
        {
            return asreader.GetSessionFlag();
        }
        public static UInt32 GetSession()
        {
            return asreader.GetSession();
        }
        public static UInt32 GetLinkProfile()
        {
            return asreader.GetLinkProfile();
        }
        public static UInt32 GetBaudRate()
        {
            return asreader.GetBaudRate();
        }
        public static UInt32 GetBaudRateList()
        {
            return asreader.GetBaudRateList();
        }
        public static UInt32 GetBarcodeTimeout()
        {
            return asreader.GetBarcodeTimeout();
        }
        public static UInt32 GetEPCMaskData()
        {
            return asreader.GetEPCMaskData();
        }
        public static string[] GetQValueList()
        {
            string[] list = new string[16];
            for (int i = 0; i < 16; i++)
            {
                list[i] = i.ToString().PadLeft(2, '0');
            }
            return list;
        }
        public static UInt32 GetInventoryMode()
        {
            return asreader.GetInventoryMode();
        }
        public static UInt32 GetPower()
        {
            return asreader.GetPower();
        }
        public static UInt32 GetPowerRange()
        {
            return asreader.GetPowerRange();
        }
        public static UInt32 GetRssiOnOff()
        {
            return asreader.GetRssiOnOff();
        }
        public static UInt32 RestoreFactorySettings()
        {
            return asreader.RestoreFactorySettings();
        }
        public static UInt32 GetFrequencyList()
        {
            return asreader.GetFrequencyList();
        }
        public static UInt32 GetFrequency()
        {
            return asreader.GetFrequency();
        }
        public static UInt32 SetBuzzer(Types.BuzzerStatus buzzerStatus)
        {
            return asreader.SetBuzzer(buzzerStatus);
        }
        public static UInt32 SetIdleTime(string idleTime)
        {
            return asreader.SetIdleTime(idleTime);
        }
        public static UInt32 SetAutoOffSleep(string autoOffSleepTime)
        {
            return asreader.SetAutoOffSleep(autoOffSleepTime);
        }
        public static UInt32 SetAutoOffTime(string autoOffTime)
        {
            return asreader.SetAutoOffTime(autoOffTime);
        }
        public static UInt32 SetQValue(string value)
        {
            return asreader.SetQValue(value);
        }
        public static UInt32 SetBarcodeTimeout(string value)
        {
            return asreader.SetBarcodeTimeout(value);
        }
        public static UInt32 SetLinkProfile(string linkProfile)
        { 
            return asreader.SetLinkProfile(linkProfile);
        }
        public static UInt32 SetFrequencyAutomatic()
        {
            return asreader.SetFrequencyAutomatic();
        }
        public static UInt32 SetSession(int session)
        {
            return asreader.SetSession(session);
        }
        public static UInt32 SetInventoryMode(Types.InventoryMode inventoryMode)
        {
            return asreader.SetInventoryMode(inventoryMode);
        }
        public static UInt32 SetSessionFlag(int sessionFlag)
        {
            return asreader.SetSessionFlag(sessionFlag);
        }
        public static UInt32 SetPowerGain(int power)
        {
            return asreader.SetPowerGain(power);
        }
        public static UInt32 SetRssiOnOff(Types.RssiOnOff onOff)
        {
            return asreader.SetRssiOnOff(onOff);
        }
        public static UInt32 SetOperationTime(string operationTime)
        {
            return asreader.SetOperationTime(operationTime);
        }
        public static UInt32 SetFrequencyAssigned(int[] frequencies)
        {
            return asreader.SetFrequencyAssigned(frequencies);
        }
        public static UInt32 SetBaudRate(int baudRate)
        {
            return asreader.SetBaudRate(baudRate);
        }
        public static UInt32 SetEPCMaskData(int offset, string mask, int length)
        {
            return asreader.SetEPCMaskData(offset, mask, length);
        }
        public static UInt32 ClearEPCMaskData()
        {
            return asreader.ClearEPCMaskData();
        }
        public static UInt32 StartBarcodeScan()
        {
            return asreader.StartBarcodeScan();
        }
        public static UInt32 Stop()
        {
            return asreader.Stop();
        }
        public static UInt32 StartInventory()
        {
            return asreader.StartInventory();
        }
        public static UInt32 StartInventoryMoisture()
        {
            return asreader.StartInventoryMoisture();
        }
        public static UInt32 StartInventoryTemperature()
        {
            return asreader.StartInventoryTemperature();
        }
        public static UInt32 Read(Types.DataArea dataArea, int offset, int length, string password)
        {
            return asreader.Read(dataArea, offset, length, password);
        }
        public static UInt32 Write(Types.DataArea dataArea, int offset, string writeData, string password)
        {
            return asreader.Write(dataArea, offset, writeData, password);
        }
        public static UInt32 Lock(bool isLockKillPwd, bool isLockAccessPwd, bool isLockEPC, bool isLockTID, bool isLockUser, string password)
        {
            return asreader.Lock(isLockKillPwd, isLockAccessPwd, isLockEPC, isLockTID, isLockUser, password);
        }
        public static UInt32 UnLock(bool isLockKillPwd, bool isLockAccessPwd, bool isLockEPC, bool isLockTID, bool isLockUser, string password)
        {
            return asreader.UnLock(isLockKillPwd, isLockAccessPwd, isLockEPC, isLockTID, isLockUser, password);
        }
        public static UInt32 PermaLock(bool isLockKillPwd, bool isLockAccessPwd, bool isLockEPC, bool isLockTID, bool isLockUser, string password)
        {
            return asreader.PermaLock(isLockKillPwd, isLockAccessPwd, isLockEPC, isLockTID, isLockUser, password);
        }
        public static UInt32 Kill(string killPwd)
        {
            return asreader.Kill(killPwd);
        }
        public static UInt32 SetAccessPassword(string accessPassword, string password)
        {
            return asreader.SetAccessPassword(accessPassword, password);
        }
        public static UInt32 SetKillPassword(string killPassword, string password)
        {
            return asreader.SetKillPassword(killPassword, password);
        }
        public static UInt32 GetTemperature()
        {
            return asreader.GetTemperature();
        }
        public static UInt32 SetTemperature(int onOff, double threshold, int action)
        {
            return asreader.SetTemperature(onOff, threshold, action);
        }
        static byte[] command = { };
        public static UInt32 RequestUpdateFirmware()
        {
            //~r<+\r\n
            command = new byte[] { 0x7E, 0x72, 0x3C, 0x0D, 0x0A };
            return asreader.Send(command);
        }
        public static UInt32 RequestUpdateRFIDFirmware()
        {
            //~w{+ 5A0001040100060000000000003F7A +\r\n
            command = new byte[] { 0x7E, 0x77, 0x7B,
                0x5A, 0x00, 0x01, 0x04, 0x01, 0x00, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00,0x00, 0x3F, 0x7A,
                0x0D, 0x0A };
            return asreader.Send(command);
        }
        public static UInt32 StartUpdateFirmware()
        {
            //~w=W3+\r\n
            command = new byte[] { 0x7E, 0x77, 0x3D, 0x57, 0x33, 0x0D, 0x0A };
            return asreader.Send(command);
        }
        public static UInt32 UpdateRFIDFirmware(UInt32 pkgNo, byte[] buffer)
        {
            //~w^+固定段(五个字节5A00010401)+ 总长度(两个字节0106)+ 数据包序号 (四个字节从1开始00000001)+ 升级包长度 (两个字节0100) +256个字节数据+ 校验（两个字节）+尾(两个字节)
            byte[] fixedPart = new byte[] {0x5A, 0x00, 0x01, 0x04, 0x01};
            try
            {
                int pkgNoLength = 4;
                //总长度
                int totalLength = pkgNoLength + 2 + buffer.Length;
                string hextotalLen = totalLength.ToString("X4");
                string hexPkgNoLen = pkgNo.ToString("X8");
                string hexPkgLen = buffer.Length.ToString("X4");
                //校验码从固定段开始
                byte[] checkTmp = new byte[4 + 2 + pkgNoLength + 2 + buffer.Length];
                //指令总长度
                command = new byte[3 + 5 + 2 + pkgNoLength + 2 + buffer.Length + 2 + 2];
                //校验：固定段(五个字节5A00010401)+ 总长度(两个字节0106)+ 数据包序号 (四个字节从1开始00000001)+ 升级包长度 (两个字节0100) +256个字节数据
                int fixlength = fixedPart.Length;
                Array.Copy(fixedPart, 1, checkTmp, 0, 4);
                checkTmp[4] = Convert.ToByte(hextotalLen.Substring(0, 2), 16);
                checkTmp[5] = Convert.ToByte(hextotalLen.Substring(2, 2), 16);
                checkTmp[6] = Convert.ToByte(hexPkgNoLen.Substring(0, 2), 16);
                checkTmp[7] = Convert.ToByte(hexPkgNoLen.Substring(2, 2), 16);
                checkTmp[8] = Convert.ToByte(hexPkgNoLen.Substring(4, 2), 16);
                checkTmp[9] = Convert.ToByte(hexPkgNoLen.Substring(6, 2), 16);
                checkTmp[10] = Convert.ToByte(hexPkgLen.Substring(0, 2), 16);
                checkTmp[11] = Convert.ToByte(hexPkgLen.Substring(2, 2), 16);
                Array.Copy(buffer, 0, checkTmp, 12, buffer.Length);
                string hexCheck = CRC16_CCITT(checkTmp, (ushort)checkTmp.Length).ToString("X4");
                //~w> + 长度（两个字节）+包的编号+ 256个字节数据 ）+ 校验（两个字节）+尾(两个字节)
                command[0] = 0x7E;
                command[1] = 0x77;
                command[2] = 0x5E;
                command[3] = 0x5A;
                Array.Copy(checkTmp, 0, command, 4, checkTmp.Length);
                command[command.Length - 4] = Convert.ToByte(hexCheck.Substring(0, 2), 16);
                command[command.Length - 3] = Convert.ToByte(hexCheck.Substring(2, 2), 16);
                command[command.Length - 2] = 0x0D;
                command[command.Length - 1] = 0x0A;
                return asreader.Send(command);
            }
            catch (Exception ex)
            {
                Console.WriteLine("UpdateRFIDFrimware:" + ex.Message);
                return 1;
            }
        }
        public static UInt32 UpdateFirmware(byte pkgNo, byte[] buffer)
        {
            try
            {
                int pkgNoLength = 1;

                //transferFile = new byte[pkgNoLength + transferDataLength];
                //transferFile[0] = pkgNo;
                //长度 = 包的编号+ 256个字节数据  + 校验  (最后一帧除外，字节数据不一定是256)+尾
                int length = pkgNoLength + buffer.Length + 2 + 2;
                string hexLen = length.ToString("X4");
                byte[] checkTmp = new byte[2 + pkgNoLength + buffer.Length];
                command = new byte[5 + 2 + pkgNoLength + buffer.Length + 2];
                //校验：长度 + 包的编号 + 256个字节数据 CRC16校验
                checkTmp[0] = Convert.ToByte(hexLen.Substring(0, 2), 16);
                checkTmp[1] = Convert.ToByte(hexLen.Substring(2, 2), 16);
                checkTmp[2] = pkgNo;
                Array.Copy(buffer, 0, checkTmp, 3, buffer.Length);
                string hexCheck = CRC16_CCITT_FALSE(checkTmp, (uint)checkTmp.Length).ToString("X4");
                //~w> + 长度（两个字节）+包的编号+ 256个字节数据 ）+ 校验（两个字节）+尾(两个字节)
                command[0] = 0x7E;
                command[1] = 0x77;
                command[2] = 0x3E;
                command[3] = Convert.ToByte(hexLen.Substring(0, 2), 16);
                command[4] = Convert.ToByte(hexLen.Substring(2, 2), 16);
                command[5] = pkgNo;
                Array.Copy(buffer, 0, command, 6, buffer.Length);
                command[command.Length - 4] = Convert.ToByte(hexCheck.Substring(0, 2), 16);
                command[command.Length - 3] = Convert.ToByte(hexCheck.Substring(2, 2), 16);
                command[command.Length - 2] = 0x0D;
                command[command.Length - 1] = 0x0A;
                return asreader.Send(command);
            }
            catch (Exception ex)
            {
                Console.WriteLine("UpdateFrimware:" + ex.Message);
                return 1;
            }
        }
        public static UInt32 UpdateFirmwareComplete()
        {
            //~w?+\r\n
            command = new byte[] { 0x7E, 0x77, 0x3F, 0x2B, 0x0D, 0x0A };
            return asreader.Send(command);
        }
        public static UInt32 UpdateRFIDFirmwareComplete()
        {
            //~w|+ 5A000104010006FFFFFFFF0000B5AA +\r\n
            command = new byte[] { 0x7E, 0x77, 0x7C,
                0x5A, 0x00, 0x01, 0x04, 0x01, 0x00, 0x06, 0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0xB5, 0xAA,
                0x0D, 0x0A };
            return asreader.Send(command);
        }
        public static UInt32 RestartRFIDFirmware()
        {
            //~w}+5A0001010F0000F0D4+\r\n
            command = new byte[] { 0x7E, 0x77, 0x7D,
                0x5A, 0x00, 0x01, 0x01, 0x0F, 0x00, 0x00, 0xF0, 0xD4,
                0x0D, 0x0A };
            return asreader.Send(command);
        }
        public static DataTable getComboxList(Type type)
        {
            Array arrs = System.Enum.GetValues(type);    // 获取枚举的所有值
            DataTable dt = new DataTable();
            dt.Columns.Add("value", typeof(int));
            dt.Columns.Add("name", Type.GetType("System.String"));
            string strText;
            foreach (var arr in arrs)
            {
                if (type == typeof(Types.Baudrate)) strText = Enum.Parse(type, arr.ToString()).ToString().Replace("_", "");
                else strText = Enum.Parse(type, arr.ToString()).ToString();
                DataRow aRow = dt.NewRow();
                aRow[0] = (int)arr;
                aRow[1] = strText;
                dt.Rows.Add(aRow);
            }
            return dt;
        }
        public static ushort CRC16_CCITT_FALSE(byte[] data, UInt32 datalen)
        {
            ushort wCRCin = 0xFFFF;
            ushort wCPoly = 0x1021;
            for (int j = 0; j < datalen; j++)
            {
                wCRCin ^= (ushort)(data[j] << 8);
                for (int i = 0; i < 8; i++)
                {
                    if ((wCRCin & 0x8000) > 0)
                        wCRCin = (ushort)((wCRCin << 1) ^ wCPoly);
                    else
                        wCRCin = (ushort)(wCRCin << 1);
                }
            }
            return (wCRCin);
        }
        public static ushort CRC16_CCITT(byte[] pchMsg, ushort wDataLen) {
            ushort CRC_16_CCITT = 0x1021;
            byte i, chChar;
            ushort wCRC = 0;
            for (int j = 0; j < wDataLen; j++)
            {
                chChar = pchMsg[j];
                wCRC ^= (ushort)(chChar << 8);
                for (i = 0; i < 8; i++)
                {
                    if ((wCRC & 0x8000) > 0)
                        wCRC = (ushort)((wCRC << 1) ^ CRC_16_CCITT);
                    else
                        wCRC <<= 1;
                }
            }
            return wCRC;
        }
    }
}
